﻿

/*:ja
 *@plugindesc ブラックジャック
 *@author うるふ
 *
 *@param Unknown Date
 *@desc ブラックジャック
 *default 不明
 *
 *@help
 *
 *プラグインコマンド:
 *  BlackJack main;	#テスト
 *
 *
 *メモ：
 *マックス２６枚
 *
 *
 */

(function(){
	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	//画像番号
	var n = 0;
	//ｘ座標
	var x = 150;
	//ｙ座標
	var y = 250;
	
	
	//合計1
	var plyer_score1 = 0;
	//合計2
	var plyer_score2 = 0;


	//ディーラの表示画像関係
	//画像番号
	var nD = 10;
	
	//ｘ座標
	var xD = 250;
	//ｙ座標
	var yD = 50;
	//表示するトランプ番号
	var numD = 0;
	
	//合計1
	var oppone_score1 = 0;
	//合計2
	var oppone_score2 = 0;

	//画像の配列
	var img = new Array(10);

	//画像フラグ(使用は1~26）裏を１枚追加
	var img_flag = new Array(28);

	//フラグ初期化
	for(var i = 0 ; i < 27 ; i++){
		img_flag[i] = 0;
	}

	//画像セット
	img[0] = "カード";//使用不可
	img[1] = "tranp_S1";
	img[2] = "tranp_S2";
	img[3] = "tranp_S3";
	img[4] = "tranp_S4";
	img[5] = "tranp_S5";

	img[6] = "tranp_S6";
	img[7] = "tranp_S7";
	img[8] = "tranp_S8";
	img[9] = "tranp_S9";
	img[10] = "tranp_S10";

	img[11] = "tranp_S11";
	img[12] = "tranp_S12";
	img[13] = "tranp_S13";

	img[14] = "tranp_H1";
	img[15] = "tranp_H2";
	img[16] = "tranp_H3";
	img[17] = "tranp_H4";
	img[18] = "tranp_H5";

	img[19] = "tranp_H6";
	img[20] = "tranp_H7";
	img[21] = "tranp_H8";
	img[22] = "tranp_H9";
	img[23] = "tranp_H10";

	img[24] = "tranp_H11";
	img[25] = "tranp_H12";
	img[26] = "tranp_H13";

	img[27] = "tranp_C1";
	img[28] = "tranp_C2";
	img[29] = "tranp_C3";
	img[30] = "tranp_C4";
	img[31] = "tranp_C5";

	img[32] = "tranp_C6";
	img[33] = "tranp_C7";
	img[34] = "tranp_C8";
	img[35] = "tranp_C9";
	img[36] = "tranp_C10";

	img[37] = "tranp_C11";
	img[38] = "tranp_C12";
	img[39] = "tranp_C13";


	img[40] = "tranp_D1";
	img[41] = "tranp_D2";
	img[42] = "tranp_D3";
	img[43] = "tranp_D4";
	img[44] = "tranp_D5";

	img[45] = "tranp_D6";
	img[46] = "tranp_D7";
	img[47] = "tranp_D8";
	img[48] = "tranp_D9";
	img[49] = "tranp_D10";

	img[50] = "tranp_D11";
	img[51] = "tranp_D12";
	img[52] = "tranp_D13";

	img[53] = "tranp_back";//裏
		
	//勝敗の画像
	var hand_img = new Array(3);

	hand_img[0] = "lose";
	hand_img[1] = "drow";	
	hand_img[2] = "win";	

	//座標
	var xH = 666;
	var yH = 50;

	//ピクチャ番号
	var nH = 20;
	
	Game_Interpreter.prototype.pluginCommand = function(command,args){
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'BlackJack'){

			switch (args[0]){
			case 'main':
				$gameSystem.mainBlackJack();
				break;
			case 'oppone':
				$gameSystem.opponeBlackJack(args[1]);
				break;
			case 'clear':
				$gameSystem.clearBlackJack();
				break;
			case 'clearall':
				$gameSystem.clearallBlackJack();
				break;
		
			case 'point':
				$gameSystem.pointBlackJack(Number(args[1]));
				break;
			}
		}

	};
	
	
	//引くカード
	function rand_tranp(){
			
			//無限ループを抜ける
			var exit = 0;

			//すでに出現してある数は出さない
			do {
				
				//無限ループ阻止
				exit += 1;
				if(exit == 100){
					$gameMessage.add("強制終了");
					break;
				}				


				//乱数の発生
				var rand = Math.floor(Math.random() * 26) + 1;


			}while(img_flag[rand] == 1);//フラグ参照、すでに出たカードならもう一度やる

			//出したカードのフラグを立てる
			img_flag[rand] = 1

			return rand;//randを返す

	}

	//加算ポイント計算
	function add_scorepoint(num){

		//加算
		var add = num;
		//ハートのカードの数値を直す	
		if(add >= 14 && add <= 26){
		
		add = add % 14 + 1;
		console.log("ハート" + add);
				
		}

		//クラブのカードの数値を直す	
		if(add >= 27 && add <= 39){
		
		add = add % 27 + 1;
		console.log("クラブ" + add);
				
		}
		
		//ダイヤのカードの数値を直す	
		if(add >= 40 && add <= 51){
		
		console.log("ダイヤ" + add);
		add = add % 40 + 1;
		console.log("ダイヤ" + add);
				
		}

		//１０を超える値は１０にとどめる
		if(add > 10){
			 add = 10;
		}
		
		return add;
		
	}


	//ゲームメイン
	Game_System.prototype.mainBlackJack = function(){

		//画像数の加算
			n += 1;

			//乱数の発生
			rand = rand_tranp();

			//テスト
			$gameVariables.setValue(5,rand);	
				
			for(var i = 800 ; i > x ; i -= 50){
				//画像の表示
				$gameScreen.showPicture(n,img[rand],0,i,y,150.0,150.0,255,0)
			}
			//画像の表示
			$gameScreen.showPicture(n,img[rand],0,x,y,150.0,150.0,255,0)

			//加算ポイント計算
			var add = add_scorepoint(rand);			
				
			//加算
				plyer_score1 += add;
				$gameVariables.setValue(22,plyer_score1);

				//1の時は１１の場合の合計を用意
				if(add == 1){
				add = 11;
				}
				plyer_score2 += add;
				$gameVariables.setValue(23,plyer_score2);			


			//座標の加算
			x += 80;
	
		
	};


	//敵の行動
	Game_System.prototype.opponeBlackJack = function(turn){
		
		switch (turn){
		//最初の呼び出し
		case 'start':		
			for(var i = 0 ; i < 1; i++){
			
				numD = rand_tranp();
	
				if(nD < 11){
					//画像の表示
					$gameScreen.showPicture(nD,img[numD],0,xD,yD,150.0,150.0,255,0);

					//座標加算
					xD += 80;

					//画像数の加算
					nD += 1;
					//画像の表示(裏向き）
					$gameScreen.showPicture(nD,img[53],0,xD,yD,150.0,150.0,255,0);
				}
				else{
					//画像の表示(裏向き）
					$gameScreen.showPicture(nD,img[53],0,xD,yD,150.0,150.0,255,0);
				}
				
				//加算ポイント計算
				 var add = add_scorepoint(numD);				

				//加算
				oppone_score1 += add;
				$gameVariables.setValue(24,oppone_score1);

				//1の時は１１の場合の合計を用意
				if(add == 1){
				add = 11;
				}
				oppone_score2 += add;
				$gameVariables.setValue(25,oppone_score2);
				
	
				}

			break;

		/*case 'oneturn':
			//画像の表示
			$gameScreen.showPicture(nD,img[numD],0,xD,yD,150.0,150.0,255,0);
				break;	*/		
		case 'hit':
			

			


				//カードを引く
				numD = rand_tranp();
				
				//画像の表示
				$gameScreen.showPicture(nD,img[numD],0,xD,yD,150.0,150.0,255,0);
				//座標加算
				xD += 80;
				//画像数の加算
				nD += 1;

				//加算ポイント計算
				 var add = add_scorepoint(numD);
				
				//加算
				oppone_score1 += add;
				$gameVariables.setValue(24,oppone_score1);
				
				//1の時は１１の場合の合計を用意
				if(add == 1){
				add = 11;
				}
				oppone_score2 += add;
				$gameVariables.setValue(25,oppone_score2);
			
			
			break;
			

		}
		
	};	

	//初期化
	Game_System.prototype.clearBlackJack = function(){
		
		for(n ; n > 0 ; n--){
		$gameScreen.erasePicture(n);
		}
		//フラグ初期化
		for(var i = 0 ; i < 27 ; i++){
			img_flag[i] = 0;
		}

		for(nD ; nD > 9 ; nD--){
		$gameScreen.erasePicture(nD);
		}

		//フラグ初期化
		for(var i = 0 ; i < 27 ; i++){
			img_flag[i] = 0;
		}
		n = 0;x = 150;y = 250;add_point = 0;
			
	
		//合計1
		plyer_score1 = 0;
		//合計2
		plyer_score2 = 0;

		//ディーラ
		nD = 10;xD = 200; yD = 50;

		 numD = 0;
	
		//合計1
		 oppone_score1 = 0;
		//合計2
		 oppone_score2 = 0;


	};
	
	//勝ちなら●、負けなら×を表示させる
	Game_System.prototype.pointBlackJack = function(win){
		//画像の表示
		$gameScreen.showPicture(nH,hand_img[win],0,xH,yH,100.0,100.0,255,0);
		
		yH += 64;
		nH += 1;

	};

	//すべて初期化
	Game_System.prototype.clearallBlackJack = function(){
		$gameSystem.clearBlackJack();
		
		yH = 50;		

		for(nH ; nH  >= 20 ; nH--){
			 $gameScreen.erasePicture(nH);
		}
		


		nH = 20;
	};

})();