﻿/*:ja
*@plugindesc ハッキングゲーム
*@author うるふ
*
*@param Unknown Date
*@desc ハッキングゲーム
*default 不明
*
*@help
*
*プロトタイプ
*
*
*
*/



(function() {

  

	//変数

	//現在のレベル(0-2)
	var level = 0;

	//右、左を押しているかどうか
	var right_down = false;
	var left_down = false;

	//セキュリティ最大個数
	var security_spon_num = 6;

	//セキュリティ出現座標
	var security_x_posi = [204,408,616];

	//セキュリティ出現フレームカウント
	var security_count = 0;
	
	//セキュリティ出現フレーム
	var s_count_max = 90;
	
	//セキュリティ番号
	var s_num = 0;
	//出現中？(0=false 1=true)
	var security_flag = [0,0,0,0,0,0];

	//セキュリティ座標
	var security_x = [408,408,408,408,408,408];
	var security_y = [-40,-40,-40,-40,-40,-40];

	//プレイヤー座標
	var plyer_x = 408;
	var plyer_y = 574;

	//プレイヤー透明度
	var plyer_clear = 255;

	//接触判定数値
	var detection_point = 35;

	//無敵時間
	var super_time = 30;
	var super_count = 0;

	//背景移動ｙ座標
	var back_y = [44,-536,-1116];

	//HP
	var hart_count = 4;
	var hart_max = 4;


	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Hack_Game'){

			switch (args[0]){

			case 'start':
				$gameSystem.startHackGame();
				break;	
			case 'main':
				$gameSystem.mainHackGame();
				break;	
			case 'end':
				$gameSystem.endHackGame();
				break;	
		
			}
		}

	};
		

	//ゲームスタートメソット
	Game_System.prototype.startHackGame = function()
	{
		//変数初期化
		
		//現在のレベル
		level = 0;
	
		//右、左を押しているかどうか
		right_down = false;
		left_down = false;

		//出現フレームカウント
		security_count = 0;
		//セキュリティ出現フレーム
		s_count_max = 180;

		//セキュリティ出現カウント
		s_num = 0;
		//出現中？(0=false 1=true)
		security_flag = [0,0,0,0,0,0];

		//座標リセット
		for(var i = 0 ; i <= security_spon_num ; i++)
		{
			security_y[i] = -40;
			security_x[i] = 408;
		}

		//プレイヤー座標
		plyer_x = 408;
		plyer_y = 574;

		//プレイヤー透明度
		pluer_clear = 255;
		//HP(モバイルは１つ増量、パニックカード使用で１つ増量）
		hart_max = 4;

		//モバイルはハートを一つ増量
		if(Utils.isMobileDevice() == true)
		{
			hart_max += 1;
		}

		//パニックカード使用で一つ増量
		if($gameSwitches.value(12) == true)
		{
			hart_max += 1;
			console.log("ハートの数" + hart_max);
		}

		hart_count = hart_max;

		//無敵カウント
		super_count = 0;

		//ｙ座標更新用
		var y = 562;

		//ハートを出していく
		for(var i = 30; i<= 30 + hart_max - 1 ; i++)
		{
	
			$gameScreen.showPicture(i,"Hack_hert",1,754,y,100.0,100.0,255,0);
			y -= 74;
		}

		var x = 204;
		for(var i = 20 ; i <= 22; i++)
		{
		
			$gameScreen.showPicture(i,"Hack_ber",1,x,312,100.0,100.0,255,0);
			x += 204;
		}
	
		$gameScreen.showPicture(41,"Hack_hacker",1,plyer_x,plyer_y,100.0,100.0,255,0);
			
		//背景の描画
		$gameScreen.showPicture(1,"Hack_Back1",0,0,back_y[0],100.0,100.0,255,0);
		$gameScreen.showPicture(2,"Hack_Back2",0,0,back_y[1],100.0,100.0,255,0);
		$gameScreen.showPicture(3,"Hack_Back1",0,0,back_y[2],100.0,100.0,255,0);
			
	};

	//ゲームクリア
	function Game_Clear()
	{

		$gameSwitches.setValue(13,true);
		$gameVariables.setValue(4,plyer_x);
		
		
	}

	//ゲームオーバー
	function Game_Over()
	{
		
		$gameSwitches.setValue(14,true);
	}

	//ピクチャの削除（min - max)
	function Picture_Erase(min,max)
	{
	
		for(var i = min ; i <= max ; i++)
		{
			$gameScreen.erasePicture(i);
		}
	}

	//セキュリティの出現(引数のoverlapのｘ座標に来たら引き直す)
	function Security_Spon(overlap)
	{
		//新出現させた初期値を入れる
		num = s_num  % security_spon_num;

		//null座標に来ないように（２個目用）
		var exit = 0;
		do{
			//一様無限ループ禁止用
			exit += 1;
			if(exit == 100)
			{
				$gameMessage.add("強制終了");
				break;
			}	
			
			//ｘ座標をランダムで決定
			security_x[num] = security_x_posi[  Math.floor(  Math.random() * 3  ) ];

		}while(security_x[num] == overlap);


		
		security_y[num] = 40;
		security_flag[num] = 1;

		$gameScreen.showPicture(50 + num,"Hack_security",1,security_x[num],security_y[num],100.0,100.0,255,0);

		//出現セキュリティの加算
		s_num += 1;					

		//二個目が出現できないｘ座標をかえす
		return security_x[num];
	}

	//セキュリティ出現と移動
	function Security()
	{
		
		//レベルに合わせた最大カウント数を計算
		var max = s_count_max - level * 60;
		
		//フレームをカウント
		security_count = (security_count + 1) % max + 1;
		
		//一定値で出現させる
		if(security_count == max && level < 3)
		{
			
			var spon_x = Security_Spon(0);
				 
			//２つ目出現確立(パーセント）
			var spon_rap = 65;

			//二個目
			if(Math.floor( Math.random() * 100 ) <= spon_rap)
			{
				Security_Spon(spon_x);
			}

			

			//出現しているセキュリティをカウントし、一定値でレベルを上げる
			var spon = (level + 1) * 10;
			
			//レベルが２（ラストレベル）は少し長く
			if(level == 2)
			{
				spon += 45; 
			}
	
			if(s_num % spon + 1 == spon || ((s_num - 1) % spon ) + 1 == spon)
			{

	
				level += 1;
			}
			

		}

		//セキュリティを移動させていく
		for(var i = 0 ; i < security_spon_num ; i++)
		{
			//フラグがあるセキュリティを動かしていく
			if(security_flag[i] == 1)
			{
				security_y[i] += 3 + level * 5;
				$gameScreen.movePicture(50 + i,1,security_x[i],security_y[i],100.0,100.0,255,0,1);

				//下までいったら消す
				if(security_y[i] >= 664)
				{
					security_flag[i] = 0;

					//ゲームレベルが最大で、すべてのフラグを下していたらゲームクリア
					if(level >= 3)
					{
					
						//すべてのフラグを参照し、一つでも上がっていたらtrueになる
						var flag = false;
	
						for(var i = 0 ; i < security_spon_num ; i++ )
						{
						
							if(security_flag[i] != 0)
							{
								flag = true;
							}
						}

						if(flag == false)
						{
							Game_Clear();
						}
						
					}
				}
			}
		}
		
		
	}

	//接触判定
	function Detection()
	{

		super_count++;
		
		if(super_count >= super_time && plyer_clear != 255)
		{
			//プレイヤーの透明度変更
			plyer_clear = 255;
			$gameScreen.movePicture(41,1,plyer_x,plyer_y,100.0,100.0,plyer_clear,0,1);
		}

		//接触を見る	
		for(var i = 0 ; i<security_spon_num ; i++)
		{
			//接触していたらハートを減らす
			var abs_math = Math.abs(plyer_y - security_y[i]);
			if(abs_math < detection_point && plyer_x == security_x[i] && super_count >= super_time)
			{
				//無敵カウント
				super_count = 0;
			
				//効果音				
				AudioManager.playSe({"name":"Damage2","volume":90,"pitch":100,"pan":0});

				//プレイヤーの透明度変更
				plyer_clear = 100;
				$gameScreen.movePicture(41,1,plyer_x,plyer_y,100.0,100.0,plyer_clear,0,1);

				//ハートの更新
				hart_count -= 1;

				//ピクチャの削除
				Picture_Erase(30,30 + hart_max);
			
				//ｙ座標更新用
				var y = 562;

				for(var i = 30; i<= 30 + hart_count - 1 ; i++)
				{
	
					$gameScreen.showPicture(i,"Hack_hert",1,754,y,100.0,100.0,255,0);
					y -= 74;
				}

				if(hart_count <= 0)
				{
					Game_Over();
				}
				
			}



		}
	}

	//背景の移動
	function Back_Move()
	{
		for(var i = 0;i<3;i++)
		{

			back_y[i] += 2;
			$gameScreen.movePicture(i+1,0,0,back_y[i],100.0,100.0,255,0,1);
			if(back_y[i] >= 624)
			{
				back_y[i] = -1115;
			}
		}	
	}

	//ゲームメインメソット
	Game_System.prototype.mainHackGame = function()
	{

		//早送りリセット
		TouchInput._pressedTime = 0;

		Security();

		//キーボード左右取得
		right_down = Input.isPressed("right");
		left_down = Input.isPressed("left");


		//画面タッチに対応
		if(TouchInput.isPressed() == true)
		{
			if(TouchInput.x >= 408)
			{
				right_down = true;
				left_down = false;
			}
			else
			{
				right_down = false;
				left_down = true;
			}
		}
	
		//座標が変更されたか見る
		var position_change = plyer_x;

		//左右どちらのフラグが立っているかでで座標変更
		if(right_down)
		{
			
			plyer_x = 616;
		}

		else if(left_down) 
		{
			
			
			plyer_x = 204;
		}

		else
		{
			plyer_x = 408;
		}

		if(plyer_x != position_change)
		{
			AudioManager.playSe({"name":"Attack2","volume":90,"pitch":100,"pan":0});
			$gameScreen.movePicture(41,1,plyer_x,plyer_y,100.0,100.0,plyer_clear,0,1);
		}
		
		Detection();

		//背景の移動
		Back_Move();
	};

	//ゲームエンドメソット
	Game_System.prototype.endHackGame = function()
	{
		//ピクチャ削除
		$gameScreen.clearPictures();

	};




})();
