﻿/*:ja
*@plugindesc バカラ
*@author うるふ
*
*@param Unknown Date
*@desc バカラ
*default 不明
*
*@help
*
*バカラ
*
*
*
*/



(function() {

  

	//変数

	//掛け金
	var mane = new Array(2);

	//掛けた場所
	var set = new Array(2);

	//敵のＡＩをどれにするかランダム
	var rival_AI_rand = 0;


	//対戦相手の掛け金
	var enemy_mane = 0;

	//ターン数加算
	var tarn = 0;

	//得点(スコア、0=bank,1=pllyer）
	var score = new Array(2);
	
	//得点
	score[0] = 0;
	score[1] = 0;

	//バンカーが引くためのフラグ
	var bank_flag = true;
	//出力カード番号
	var number = -1;

	//画像番号
	var card_num = 30;

	//画像座標更新
	var add_x = 0;

	//画像の配列
	var img = new Array(54);

	//画像セット
	img[0] = "カード";//使用不可
	img[1] = "tranp_S1";
	img[2] = "tranp_S2";
	img[3] = "tranp_S3";
	img[4] = "tranp_S4";
	img[5] = "tranp_S5";

	img[6] = "tranp_S6";
	img[7] = "tranp_S7";
	img[8] = "tranp_S8";
	img[9] = "tranp_S9";
	img[10] = "tranp_S10";

	img[11] = "tranp_S11";
	img[12] = "tranp_S12";
	img[13] = "tranp_S13";

	img[14] = "tranp_H1";
	img[15] = "tranp_H2";
	img[16] = "tranp_H3";
	img[17] = "tranp_H4";
	img[18] = "tranp_H5";

	img[19] = "tranp_H6";
	img[20] = "tranp_H7";
	img[21] = "tranp_H8";
	img[22] = "tranp_H9";
	img[23] = "tranp_H10";

	img[24] = "tranp_H11";
	img[25] = "tranp_H12";
	img[26] = "tranp_H13";

	img[27] = "tranp_C1";
	img[28] = "tranp_C2";
	img[29] = "tranp_C3";
	img[30] = "tranp_C4";
	img[31] = "tranp_C5";

	img[32] = "tranp_C6";
	img[33] = "tranp_C7";
	img[34] = "tranp_C8";
	img[35] = "tranp_C9";
	img[36] = "tranp_C10";

	img[37] = "tranp_C11";
	img[38] = "tranp_C12";
	img[39] = "tranp_C13";


	img[40] = "tranp_D1";
	img[41] = "tranp_D2";
	img[42] = "tranp_D3";
	img[43] = "tranp_D4";
	img[44] = "tranp_D5";

	img[45] = "tranp_D6";
	img[46] = "tranp_D7";
	img[47] = "tranp_D8";
	img[48] = "tranp_D9";
	img[49] = "tranp_D10";

	img[50] = "tranp_D11";
	img[51] = "tranp_D12";
	img[52] = "tranp_D13";

	img[53] = "tranp_back";//裏

	//グラフプロットＩＤ
	var graf_num = 2;
	var plot = 0;


	//グラフの配列(1=Banker,2=Plyer,3=Tie)
	var graf = new Array(7);

	

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Baccara'){

			switch (args[0]){

			case 'start':
				$gameSystem.startBaccara();
				break;

			case 'drowplyer':
				$gameSystem.drowplyerBaccara();
				break;
			case 'drowbanker':
				$gameSystem.drowbankerBaccara();
				break;

			case 'startrival':
				$gameSystem.startrivalBaccara();			
				break;
				
			case 'set':
				$gameSystem.setBaccara();			
				break;

			case 'rivalcip':
				$gameSystem.setrivalBaccara();
				break;
		
			case 'riset':	
				$gameSystem.risetBaccara();			
				break;

			case 'graf':
				$gameSystem.grafBaccara();
				break;			

			case 'end':
				$gameSystem.endBaccara();
				break;
			}
		}

	};
		
	//敵ＡＩその１（直前勝った方と逆に賭ける、２回連続で勝っていたら、勝っている方に賭ける
	function Rival_AI_1()
	{	

		//直前勝った方と逆に賭ける
		switch(graf[plot - 1])
		{
		case 1:
			set[1] = 2;
			console.log("プレイヤーに");
			break;
		case 2:
			set[1] = 1;
			console.log("バンカーに");
			break;
		//引き分けと初手はバンカーに賭ける
		default:
			set[1] = 1;
			console.log("バンカーに");
			break;
		}
	
		//２回勝っていたら勝った方に賭ける
		if($gameVariables.value(17) >= 3)
		{
			
			if(graf[plot - 2] == graf[plot - 1])
			{
				set[1] = graf[plot - 1];
				console.log("勝っている方に");
			}
		
		}

	}

	//敵ＡＩその２（直前勝った方に賭ける）
	function Rival_AI_2()
	{
		//直前勝った方に賭ける	
		set[1] = graf[plot - 1];
		//初手はプレイヤーに賭ける
		if(plot == 0)
		{
			set[1] = 2;
		} 
	}

	function Rival_AI_3()
	{
		set[1] = Math.floor(Math.random() * 2) + 1;
		//初手は引き分けに賭ける
		if(plot == 0)
		{
			set[1] = 3;
		} 
	}
	

	//引くカード
	function rand_tranp(){
			
			//無限ループを抜ける
			var exit = 0;


			//乱数の発生
			var rand = Math.floor(Math.random() * 51) + 1;

			return rand;//randを返す

	}

	//加算ポイント計算
	function add_scorepoint(num){

		//加算
		var add = num;
		//ハートのカードの数値を直す	
		if(add >= 14 && add <= 26){
		
		add = add % 14 + 1;
		console.log("ハート" + add);
				
		}

		//クラブのカードの数値を直す	
		if(add >= 27 && add <= 39){
		
		add = add % 27 + 1;
		console.log("クラブ" + add);
				
		}
		
		//ダイヤのカードの数値を直す	
		if(add >= 40 && add <= 51){
		
		console.log("ダイヤ" + add);
		add = add % 40 + 1;
		console.log("ダイヤ" + add);
				
		}


		//１０を超える値は０にする
		if(add > 10){
			 add = 0;
		}
		
		return add;
		
	}

	//得点加算(加算する相手（０＝バンカー、1＝プレイヤー）)ついでにカードの番号を返す
	function Score(i)
	{
			//引くカードの番号
			var num = rand_tranp();
			
			//プレイヤー得点セット
			var plyer_mane = score[i];
			plyer_mane += add_scorepoint(num);
			
			if(plyer_mane >= 10 )
			{
				plyer_mane -= 10;
			}
			score[i] = plyer_mane;	
			$gameVariables.setValue(32 + i,plyer_mane);
			return num;			
	}

	//配当金
	function Mane_Juge(w,i,invalue)
	{
		//残っているチップ
		var tip = $gameVariables.value(invalue) - mane[i];
	
		//ベットした場所が勝ったら
		if(w == set[i])
		{
			//それぞれの配当金がもらえる
			switch(w)
			{
			case 1:
				mane[i] *= 1.95;
				break;
			case 2:
				mane[i] *= 2;
				break;
			case 3:
				mane[i] *= 8;
				break;
			}
		}
		//引き分けだったらそのまま戻る
		else if(w == 3)
		{
			mane[i] = mane[i];
		}
		//予想が外れたら、金がなくなる
		else
		{
			mane[i] = 0;
		}
		//console.log(mane[i]);
		$gameVariables.setValue(invalue,tip + mane[i]);
	}
	
	
	//表の情報を更新する
	function Graf_Plot(win)
	{
		graf[plot] = win;
		plot += 1;
	}


	//勝敗を見る
	function Juge()
	{
		var win = 0;
		//引き分け
		if(score[0] == score[1])
		{
			win = 3;
		}
		//バンカー勝利
		else if(score[0] > score[1])
		{
			win = 1;
		}
		//プレイヤー勝利
		else
		{
			win = 2;
		}
		Mane_Juge(win,0,35);
		Mane_Juge(win,1,15);
		$gameVariables.setValue(34,win);
		//グラフ情報更新
		Graf_Plot(win);
	}

	//ターン、次のターンにすすむか判定
	function Tarn_Juge()
	{

			if(tarn == 2)
			{
				if(score[0] >= 8 || score[1] >= 8)
				{
					//$gameMessage.add("ナチュラル");
					Juge();
					
				}
				else if(score[0] >= 6 && score[1] >= 6)
				{
					//$gameMessage.add("双方６以上");
					Juge();
				}
			}

			if(tarn == 3)
			{
				//$gameMessage.add("3end");			
				Juge();
			}
		
	}

	//バンカー３枚目引くかどうかの判定
	function Bank_Juge(num)
	{
		var flag = false;

		
		//ハンドが3以下の時
		if(score[0] <= 3)
		{
			//$gameMessage.add("ハンドが３以下で");
			if(score[0] == 3 && num == 8)
			{
				//$gameMessage.add("ハンドが３で");
				//$gameMessage.add("プレイヤーの引きが８である");
				flag = false;
			}
			else
			{
				//$gameMessage.add("ハンドが３で");
				//$gameMessage.add("プレイヤーの引きが８ではない");
				flag = true;
			}
		}

		//ハンドが４の時
		if(score[0] == 4)
		{
			//$gameMessage.add("ハンドが４で");
			if(num >= 2 && num <= 7)
			{
				//$gameMessage.add("プレイヤーの引き４～７である");
				flag = true;
			}
			else
			{
				//引かない時でも引く
				if(num == -1)
				{
					//$gameMessage.add("プレイヤーが引かなかった");
					flag = true;
				}
				else
				{
					//$gameMessage.add("プレイヤーが引いた");
					flag = false;
				}
			}

		}
		//ハンドが５の時
		if(score[0] == 5)
		{
			//$gameMessage.add("ハンドが５で")
			if(num >= 2 && num <= 7)
			{
				//$gameMessage.add("プレイヤーの引きが２～７である");
				flag = true;
			}
			else
			{
				//引かない時でも引く
				if(num == -1)
				{
					//$gameMessage.add("プレイヤーが引かなかった");
					flag = true;
				}
				else
				{
					//$gameMessage.add("プレイヤーが引いた");
					flag = false;
				}
			}

		}

				
		if(score[0] == 6)
		{
			//$gameMessage.add("ハンドが６で")
			if(num >= 6 && num <= 7)
			{
				//$gameMessage.add("プレイヤーの引きが６～７である");
				flag = true;
			}
			else
			{
				//$gameMessage.add("プレイヤーの引きが６～７ではない");
				flag = false;
			}
		}
		
		if(score[0] >= 7)
		{
			//$gameMessage.add("ハンドが７以上である")
			flag == false;
		}
		$gameSwitches.setValue(13,flag);
		return flag;		
		
	}


	//カードを引くメソット（プレイヤー）
	Game_System.prototype.drowplyerBaccara = function()
	{

			//変数初期化
			bank_flag = true;
			number = -1;

			
			//プレイヤー、ターン３の時は５以下の時に引く
			if(tarn < 3 || score[1] <= 5)
			{
				number = Score(1);
				$gameScreen.showPicture(card_num,img[number],1,486 + add_x,360,200.0,200.0,255,0);
				card_num += 1;	
			}
			
			
			//ターン３の時にバンカーが引くか決める
			if(tarn == 3)
			{
				if(number >= 10){ number = 0; }
				bank_flag = Bank_Juge(number);
			}
	
	};

	//カードを引くメソット(バンカー）
	Game_System.prototype.drowbankerBaccara = function()
	{


			//フラグがオンの時に引く
			if(bank_flag == true)
			{
				number = Score(0);
				$gameScreen.showPicture(card_num,img[number],1,330 - add_x,360,200.0,200.0,255,0);
			}
			

			Tarn_Juge();
			
			card_num += 1;
			add_x += 100;
			tarn += 1;


	};

	//グラフのリセット
	function Graf_Riset()
	{
		//グラフ変数リセット
		graf_num = 2;
		plot = 0;

		//すべての変数を０に
		for(var i = 0; i< 7; i++)
		{
			graf[i] = 0;
		}
		
	}

	//ゲームスタートメソット
	Game_System.prototype.startBaccara = function()
	{
		//変数初期化
		card_num = 30;	

		//グラフ連勝
		var con_win = 0;

		//掛け金
		mane[0] = 0;
		mane[1] = 0;
		//対戦相手の掛け金
		enemy_mane = 0;
		
		//ターン数加算
		tarn = 1;

		//敵のＡＩをランダムで決定
		raival_AI_rand = Math.floor(Math.random() * 101);
		 
		
		//得点
		score[0] = 0;
		score[1] = 0;

		//掛け金
		mane[0] = 0;
		mane[1] = 0;


		//画像座標更新
		var add_x = 0;

		//グラフ情報リセット
		Graf_Riset();		
							
	};

	//賭けた場所によってチップの場所を変える
	function Tip_Position(set)
	{
		var set_position;

		switch (set){	
		
		case 3:
			set_position = 408;
			break;
		case 1:
			set_position = 308;
			break;
		case 2:
			set_position = 508;
			break;
		}		
	
		return set_position;

	}

	//敵のＡＩをどれにするかランダムで算出したものを実行
	function Rival_AI()
	{

		console.log(raival_AI_rand);
		//敵が賭ける
		if(raival_AI_rand < 30 )
		{
			
			Rival_AI_1();
			console.log("AI_1");
		}
		else if(raival_AI_rand < 65)
		{
			Rival_AI_2();
			console.log("AI_2");
			
		}
		else
		{
			Rival_AI_3();
			console.log("AI_3");
		}
		$gameVariables.setValue(46,set[1]);


	}

	//バカラセッティングメソット
	Game_System.prototype.setBaccara = function()
	{

		//画像の削除
		$gameSystem.wolfPictureErase(30,card_num);
		//表画像の削除
		$gameSystem.wolfPictureErase(1,graf_num);

		//バンカーとプレイヤーの勝敗リセット
		$gameVariables.setValue(34,0);

		//掛けた場所
		set[0] = $gameVariables.value(30);


		//チップの場所
		var set_position = 0;

		//変数初期化
		card_num = 30;	

		//ターン数加算
		tarn = 1;

		//効果音鳴らすためのフラグ
		$gameSwitches.setValue(13,false);		

		//得点
		score[0] = 0;
		score[1] = 0;
		
		//画像座標更新
		add_x = 0;


		//プレイヤーのチップ位置をセット
		set_position = Tip_Position(set[0]);
		AudioManager.playSe({"name":"key","volume":90,"pitch":100,"pan":0});
		$gameScreen.showPicture(20,"Baccara_MY_Cip",1,set_position,524,100.0,100.0,255,0);


		//掛け金
		mane[0] = $gameVariables.value(31);		
		console.log(mane[0]);	
		mane[1] = $gameVariables.value(15) / 5;//敵は持ちチップの５分の１を賭けていく
		console.log(mane[1]);	
	};

	//バカラセッティングメソット
	Game_System.prototype.setrivalBaccara = function()
	{
		//敵のチップ位置をセット
		var set_position = Tip_Position(set[1]);
		set_position += 20;
		AudioManager.playSe({"name":"key","volume":90,"pitch":100,"pan":0});
		$gameScreen.showPicture(21,"Baccara_Rival_Cip",1,set_position,544,100.0,100.0,255,0);
	};

	//出力する画像を返す
	function Graf_Img(num)
	{
		var img;
		if(num == 1)
		{
			img = "Baccara_Banker";
		}

		if(num == 2)
		{

			img = "Baccara_Plyer";
		}
		if(num == 3)
		{
			img = "Baccara_Tie";
		}	
		
		return img;
	}

	//グラフの描画と更新
	Game_System.prototype.startrivalBaccara = function()
	{	
		//敵が賭ける（ここでけっていして、セリフを出させる）
		Rival_AI();
		//計算用１にセットした場所の情報を渡して、セリフを出す
		$gameVariables.setValue(4,set[1]);
	};

	//グラフの描画と更新
	Game_System.prototype.grafBaccara = function()
	{


		//表の表示
		$gameScreen.showPicture(1,"Baccara_Graf2",0,10,400,100.0,100.0,255,0);
		
	
	
		//グラフプロット用変数
		//座標
		var graf_x = 36;
		var graf_y = 548;
		//画像
		var graf_img = "Baccara_Banker";
		
		//ＩＤ初期化
		graf_num = 2;

		
		//グラフを読み取ってプロットしていく
		var i = 0;
		while(graf[i] != 0)
		{
			graf_img = Graf_Img(graf[i]);
			$gameScreen.showPicture(graf_num,graf_img,1,graf_x,graf_y,100.0,100.0,255,0);
			graf_x += 45;
			graf_num += 1;
			i += 1;
		}
	
		
		
		
	}


	//ゲーム画面、変数のリセット
	Game_System.prototype.risetBaccara = function()
	{
		//画像の削除
		//$gameSystem.wolfPictureErase(30,card_num);
		//画像の削除
		//$gameSystem.wolfPictureErase(20,21);
		
		//効果音鳴らすためのフラグ
		$gameSwitches.setValue(13,false);		
		//ピクチャ削除
		$gameScreen.clearPictures();
				
	};
	

	
	//ゲーム終了
	Game_System.prototype.endBaccara = function()
	{
		//ピクチャ削除
		$gameScreen.clearPictures();
		
		$gameSystem.wolfSwitchesRiset(13,13);		
		
		//凡庸変数のリセット
		$gameSystem.wolfVariablesRiset(15,17);
		console.log("end");
				
	};



})();
