﻿/*:ja
*@plugindesc 間違い探しゲーム
*@author うるふ
*
*@param Unknown Date
*@desc 間違い探しゲーム
*default 不明
*
*@help
*
*間違い探しゲーム
*
*
*
*/



(function() {

  

	//変数///////////////////////////////////

	//問題番号
	var q_num = 0;

	//問題レベル
	var q_level = 0;

	//時間間隔
	var time_wait = 30;

	//時間のカウント
	var time_count = 0;
	//時間カウントの画像
	var time_img = new Array();


	for(var i = 0 ; i < 3 ; i++)
	{
		time_img[i] = "Diff_Time_" + (i + 1);
	}

	function Value_Riset()
	{
		q_num = 0;
		q_level = 0;
		time_count = 0;
	}

	///////////////////////////////////////

	//効果音/////////////////////////////////////

	//効果音（０＝タイムカウント、１＝正解、２＝不正解
	function SE(num)
	{
		switch(num)
		{
		case 0:
			AudioManager.playSe({"name":"button08","volume":90,"pitch":100,"pan":0});
			break;
		case 1:
			AudioManager.playSe({"name":"Skill3","volume":90,"pitch":100,"pan":0});
			break;
		case 2:
			AudioManager.playSe({"name":"Buzzer2","volume":90,"pitch":100,"pan":0});
			break;
		}
			
	}

	////////////////////////////////////////////

	//表示////////////////////////////////////

	//ボタンの表示
	function Pix_Button()
	{
		$gameScreen.showPicture(30,"Diff_Button",1, 408, 312,100.0, 100.0, 255, 0);

	}

	///////////////////////////////////////////

	//処理/////////////////////////////////////

	//セットアップ
	function Set()
	{
		//画像の削除
		$gameScreen.clearPictures();

		$gameVariables.setValue(16,0);

		//問題の出題
		q_num = Math.floor(Math.random() * 3) + q_level;
		$gameVariables.setValue(15,q_num);

		//問題レベルの上昇
		q_level += 3;
	
		time_count = 0;
		Pix_Button();
	}

	//問題判定
	function Check_Q(button,q_num)
	{
		if(button == q_num % 3)
		{
			SE(1);
			console.log("正解");
			$gameVariables.setValue(16,1);
		}
		else
		{
			SE(2);
			console.log("不正解");
			$gameVariables.setValue(16,2);
		}
	}



	//選択
	function Check_Button()
	{

		var check = -1;
		if( (TouchInput.x <= 268 && $gameSystem.wolfOneTouch() == true) || (Input.isTriggered("left") == true))
		{
			console.log("0");
			check = 0;
			//正誤のチェック
			 Check_Q(check,q_num);

		}
		else if( (TouchInput.x <= 546 && $gameSystem.wolfOneTouch() == true ) || (Input.isTriggered("up") == true || Input.isTriggered("down") == true ))
		{
			console.log("1");
			check = 1;
			//正誤のチェック
			 Check_Q(check,q_num);

		}
		else if( (TouchInput.x > 546 && $gameSystem.wolfOneTouch() == true ) || Input.isTriggered("right") == true)
		{
			console.log("2");
			check = 2;
			//正誤のチェック
			 Check_Q(check,q_num);

		}

	}

	//タイム
	function Time_Up()
	{
		time_count += 1;


		if(time_count == time_wait * 2)
		{
			SE(0);
			$gameScreen.showPicture(31,time_img[2],1, 408, 48,100.0, 100.0, 255, 0);
		}

		if(time_count == time_wait * 3)
		{
			SE(0)
			$gameScreen.showPicture(31,time_img[1],1, 408, 48,100.0, 100.0, 255, 0);
		}

		if(time_count == time_wait * 4)
		{
			SE(0);
			$gameScreen.showPicture(31,time_img[0],1, 408, 48,100.0, 100.0, 255, 0);
		}

		if(time_count == time_wait * 5)
		{
			SE(2);
			$gameVariables.setValue(16,2);
		}
	}



	/////////////////////////////////////////

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Diff_Game'){

			switch (args[0])
			{
			case 'set':
				$gameSystem.setDiff_Game();
				break;			

			case 'main':
				$gameSystem.mainDiff_Game();
				break;
			case 'end':
				$gameSystem.endDiff_Game();
				break;			
			case 'gameset':
				$gameSystem.gamesetDiff_Game();
				break;			

	
			}
		}

	};
		

	//ゲームセットメソット
	Game_System.prototype.setDiff_Game = function()
	{		
		Value_Riset();

	};

	//ゲームセットメソット
	Game_System.prototype.gamesetDiff_Game = function()
	{
		Set();
		
	};

	//ゲームメインメソット
	Game_System.prototype.mainDiff_Game = function()
	{

		Time_Up();
		Check_Button();
		if(Input.isTriggered("left") == true){console.log("aaa");}

	};

	//ゲームエンドメソット
	Game_System.prototype.endDiff_Game = function()
	{
		$gameScreen.clearPictures();
	};





})();
