﻿/*:ja
*@plugindesc フリースロー
*@author うるふ
*
*@param Unknown Date
*@desc フリースロー
*default 不明
*
*@help
*
*フリースロー
*
*
*
*/



(function() {

  

	//変数/////////////////////////////////////////////////////////////////////

	//マイフレームカウント
	var move_count = 0;
	//動かす速度（僕の感覚では、最大0.075、最小0.048）
	var move_spd = 0.048;
	
	//コインの座標
	var coin_y = 312;

	//コインのサイズ
	var coin_size_y = 50;

	//アッタクポイントのサイズ
	var attack_point_size_y = 80;
	var attack_point_y = 200;

	//動かしてよいかのフラグ
	var act = true;

	//ゲームのレベル
	var level = 0;

	//ヒットポイントの拡大率
	var rate = 1;

	//ヒットするポイントの幅（コインサイズｙ　＋　アタックサイズｙ　/　２）
	var hit_point = coin_size_y / 2 + attack_point_size_y / 2;

	//////////////////////////////////////////////////////////////////////

	//部品//////////////////////////////////////////////////////////////

	function Value_Riset()
	{
		level = 0;
		rate = 1;
		hit_point = coin_size_y / 2 + (attack_point_size_y / 2 / rate);
		hit_point /= rate;

		move_count = 0;
		
		move_spd = $gameVariables.value(16) * 0.0134 + 0.048;

		//アタックポイントの座標
		attack_point_y = (Math.floor(Math.random() * 34) + 14) * 10;

	}

	function Value_Update()
	{

		level += 1;
		rate += level;

		hit_point = coin_size_y / 2 + (attack_point_size_y / 2 / rate);

		//アタックポイントの座標
		attack_point_y = (Math.floor(Math.random() * 34) + 14) * 10;
		


	}

	//コインを動かすメソッド
	function Coin_Move()
	{

		move_count += move_spd;
		coin_y = Math.sin(move_count) * 187 + 312;
		
	}
	
	//プレイヤーがタッチもしくは決定を押したときにtrueを返す
	function Plyer_Action()
	{
		if($gameSystem.wolfOneTouch() || Input.isTriggered('ok'))
		{
			return true;
		}
	
	}

	//タッチした時に、コインがヒットしているのか判断する
	function Coin_Choeck()
	{
		//うるふライブラリから１タッチを受け取る
		if(Plyer_Action())
		{

			if(Math.abs(coin_y - attack_point_y) <= hit_point)
			{
				$gameVariables.setValue(15,1);
				console.log("hit_point" + hit_point + "Math.abs" + Math.abs(coin_y - 312));
			}
			else
			{
				$gameVariables.setValue(15,2);
				console.log("hit_point" + hit_point + "Math.abs" + Math.abs(coin_y - 312));
			}

		}
	
	}

	//表示//////////////////////////////////////////////////////////////

	//ピクチャの初期表示
	function Start_Picture()
	{
		$gameScreen.showPicture(1,"Throw_Bar",1,746,312,100.0,100.0,255,0);

		$gameScreen.showPicture(2,"Throw_Attack",1,746,attack_point_y,100.0,100.0 / rate,255,0);
	}

	//ピクチャの更新
	function Update_Picture()
	{
		$gameScreen.showPicture(10,"Throw_Coin",1,671,coin_y,100.0,100.0,255,0);
	}

	//メインメソッド/////////////////////////////////////////////////////////////////

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'FreeThrow'){

			switch (args[0]){

			case 'main':
				$gameSystem.mainFreeThrow();
				break;		

			case 'start':
				$gameSystem.startFreeThrow();
				break;

			case 'set':
				$gameSystem.setFreeThrow();
				break;

			case 'end':
				$gameSystem.endFreeThrow();
				break;
			}
		}

	};

	//スタートメソット
	Game_System.prototype.startFreeThrow = function()
	{
		Value_Riset();
		Start_Picture();

	};
	
	//セットアップメソット
	Game_System.prototype.setFreeThrow = function()
	{		
		Value_Update();

		Start_Picture();

			
	};

	//ゲームメインメソット
	Game_System.prototype.mainFreeThrow = function()
	{
		Coin_Move();
		Coin_Choeck();

		Update_Picture();
	
			
	};

	//エンドメインメソット
	Game_System.prototype.endFreeThrow = function()
	{
		$gameScreen.clearPictures();			
	};
	
		





})();
