﻿/*:ja
*@plugindesc うるふ作成ライブラリ
*@author うるふ
*
*@param Unknown Date
*@desc ライブラリ
*default 不明
*
*@help
*
*ピクチャ削除
*$gameSystem.wolfPictureErase(min,max);
*
*
*/



(function() {

  

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_Library'){

			
			switch (args[0]){

			case 'sort':
				$gameSystem.wolfSort();
				break;		
			}
			
		}

	};
		

	//ピクチャ削除のメソッド(min ～ max)
	Game_System.prototype.wolfPictureErase = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameScreen.erasePicture(i);
		}	
				
	};

	
	//変数初期化のメソッド(min ～ max)
	Game_System.prototype.wolfVariablesRiset = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameVariables.setValue(i,0);;
		}	
				
	};

	//スイッチ初期化のメソッド(min ～ max)
	Game_System.prototype.wolfSwitchesRiset = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameSwitches.setValue(i,false);;
		}	
				
	};

	//配列のソート
	function QSort(x,left,right)
	{
		var i = left;
		var j = right;

		var pivot = x[parseInt((left + right) / 2)];

		while(1)
		{
			while(x[i] < pivot)
			{
				i += 1;
			}

			while(x[j] > pivot)
			{
				j -= 1;
			}

			if(i >= j)
			{
				break;
			}

			Swap(x,i,j);
			i += 1;
			j -= 1;
		}
		if(left < i - 1)
		{
			QSort(x,left,i - 1);
		}
		if(right > j + 1)
		{
			QSort(x,j + 1,right);
		}

	}

	function Swap(x,i,j)
	{
		var temp;
		
		temp = x[i];
		x[i] = x[j];
		x[j] = temp;
	}

	//配列のソート
	Game_System.prototype.wolfQSort = function(x)
	{
		//ソート
		QSort(x,0,x.length-1);

		//表示
		/*for(var i = 0 ; i < x.length ; i++)
		{
			console.log(x[i]);
		}
		*/


	};

	//タッチしている時間を取得
	var touch_count;

	//１タッチにだけ、trueを返す
	Game_System.prototype.wolfOneTouch = function()
	{
		if(TouchInput.isPressed())
		{
			touch_count += 1;
		}
		else
		{
			touch_count = 0;
		}

		if(touch_count == 1)
		{
			return true;
		}
		else
		{
			return false;
		}	
	};

	
	



})();
